



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#设计模式（5）——建造者模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#设计模式（5）——建造者模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 18:01:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>1.建造者模式介绍</h2>
<p>　　在软件开发中，有时我们要创建一个复杂的对象，这个对象由几个子部件按一定的步骤组合而成，这时候我们就可以使用建造者模式了。说到建造者我们首先想到的是盖房子，盖房子简单的说有三个步骤：打地基，砌砖，粉刷。我们就以盖房子为例解释建造者模式的用法。</p>
<p>　　建造者模式有三个角色：建造者，具体的建造者，监工。理清这三个角色的作用我们就可以愉快的使用建造者模式了。</p>
<p>　　<strong>建造者</strong>：一般为抽象类或接口，定义了建造者的功能。如盖房子例子的建造者有打地基，砌砖和粉刷的功能。</p>
<p>　　<strong>具体的建造者</strong>：实现了建造者的抽象方法（或接口）。不同的具体建造者生产的组件不同，如一个技术好的建造者打地基深，砌砖整齐，粉刷光滑，而技术差的建造者打地基浅，砌砖错乱，粉刷粗糙。</p>
<p>　　<strong>监工</strong>：制定建造的算法。建造者可以打地基，砌砖，粉刷，但是不知道先粉刷还是先打地基，监工就是给建造者制定盖房子步骤的。</p>
<p>代码实现如下，</p>
<p><strong>建造者和具体建造者：</strong></p>
<div>
<pre class="prettyprint linenums">   //建造者抽象类，定义了建造者的能力<br />
    public abstract class Builder<br />
    {<br />
        public abstract void Dadiji();//打地基<br />
        public abstract void QiZhuan();//砌砖<br />
        public abstract void FenShua();//粉刷<br />
    }

    /// &lt;summary&gt;<br />
    /// 技术好的建造者<br />
    /// &lt;/summary&gt;<br />
    public class GoodBuilder : Builder<br />
    {<br />
        private StringBuilder house = new StringBuilder();<br />
        public override void Dadiji()<br />
        {<br />
            house.Append("深地基--&gt;");<br />
            //这里一般是new一个部件，添加到实例中，如 house.Diji=new Diji("深地基")<br />
            //为了演示方便 用sringBuilder表示一个复杂的房子，string表示房子的部件<br />
        }

        public override void FenShua()<br />
        {<br />
            house.Append("粉刷光滑--&gt;");<br />
        }

        public override void QiZhuan()<br />
        {<br />
            house.Append("砌砖整齐--&gt;");<br />
        }<br />
        public string GetHouse()<br />
        {<br />
            return house.Append("好质量房子建成了！").ToString();<br />
        }<br />
    }

    /// &lt;summary&gt;<br />
    /// 技术差的建造者<br />
    /// &lt;/summary&gt;<br />
    public class BadBuilder:Builder<br />
    {<br />
        private StringBuilder house = new StringBuilder();<br />
        public override void Dadiji()<br />
        {<br />
            house.Append("挖浅地基--&gt;");<br />
        }

        public override void FenShua()<br />
        {<br />
            house.Append("粉刷粗糙--&gt;");<br />
        }

        public override void QiZhuan()<br />
        {<br />
            house.Append("砌砖错乱--&gt;");<br />
        }<br />
        public string GetHouse()<br />
        {<br />
            return house.Append("坏质量房子建成了！").ToString();<br />
        }<br />
    }</pre>
</div>
<p><strong>监工：</strong></p>
<div>
<pre class="prettyprint linenums">    //监工类，制定盖房子的步骤<br />
    public class Director<br />
    {<br />
        private Builder builder;<br />
        public Director(Builder builder)<br />
        {<br />
            this.builder = builder;<br />
        }

        //制定盖房子的流程，<br />
        public void Construct()<br />
        {<br />
            builder.Dadiji();//先打地基<br />
            builder.QiZhuan();//再砌砖<br />
            builder.FenShua();//最后粉刷<br />
        }<br />
    }</pre>
</div>
<p>客户端调用：</p>
<div>
<pre class="prettyprint linenums">    class Program<br />
    {<br />
        static void Main(string[] args)<br />
        {<br />
            //监工1派遣技术好的建造者盖房子<br />
            GoodBuilder goodBuilder = new GoodBuilder();<br />
            Director director1 = new Director(goodBuilder);<br />
            director1.Construct();<br />
            string house1 = goodBuilder.GetHouse();<br />
            Console.WriteLine(house1);

            //监工2派遣技术差的建造者盖房子<br />
            GoodBuilder badBuilder = new GoodBuilder();<br />
            Director director2 = new Director(goodBuilder);<br />
            director2.Construct();<br />
            string house2 = goodBuilder.GetHouse();<br />
            Console.WriteLine(house2);<br />
            Console.ReadKey();<br />
        }<br />
    }</pre>
</div>
<p>运行结果:</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1007918/201811/1007918-20181121003013427-1373071525.png" /></p>
<h2>2.小结</h2>
<p>上边例子的类图</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1007918/201811/1007918-20181121004320419-1343060068.png" /></p>
<p><strong>建造者模式的使用场景：</strong></p>
<p>　　主要解决在软件系统中，有时候面临着"一个复杂对象"的创建工作，其通常由各个部分的子对象用一定的算法构成；由于需求的变化，这个复杂对象的各个部分经常面临着剧烈的变化，但是将它们组合在一起的算法却相对稳定，这时适合用建造者模式。StringBuilder和Quartz中的JobBuilder,TriggerBuilder都使用了建造者模式。如果每添加一个部件都返回建造对象的索引，那么我们就可以实现基本的链式构造，如JobBuilder和TriggerBuilder都可以通过Fluent&nbsp;interface形式进行构造。</p>
<p><strong>建造者模式的优点：</strong></p>
<p>　　1.实例的构建具体到组件层次，方便控制细节；</p>
<p>　　2.具体的建造者相互独立，易于扩展。</p>
<p><strong>建造者模式的缺点：</strong></p>
<p>　　当组件的组合种类很多时，需要创建很多的具体建造者类。</p>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rygv78.html">&lbrack;SonarQube&rsqb;小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq14jv0q.html">php中cookie技术关于跨目录调用cookie值的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkj3mq.html">yii redies 不同的工程缓存key的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/495n02e9.html">从DACPAC文件中读取元数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m7rj28.html">Android Listview &amp;amp&semi; Adapter</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdy74zq.html">HTML之DOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7pzj1q.html">Html - 涟漪特效</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd1jyz8.html">从Go、Swift出发：语言的选择需谨慎</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj21r5q.html">N卡全部历史驱动</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pvjln8.html">linux oops调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p6nmj8.html">Scala面向对象详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvleky8.html">小程序View内的文字不换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7onngj8.html">Modbus库开发笔记之三：Modbus TCP Server开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wgnvrq.html">大数据学习笔记2 - 分布式文件系统HDFS（待续）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv236ry9.html">opus在arm的嵌入式平台上的移植和开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2xv62q.html">结对项目-四则运算&amp;quot&semi;软件&amp;quot&semi;之升级版</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oyy6x8.html">halcon&plus;csharp多图像拼接实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/960emwn9.html">移动端touchmove卡顿</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emywoj9.html">SpringBoot扫描包提示找不到mapper的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv0mdjq.html">C&plus;&plus;操作mysql方法总结（3）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdw54m09.html">C&sol;C&plus;&plus; 程序库</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r53y48.html">Hdoj 2084&period;数塔 题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyv0kn9.html">&lbrack;CF1131C&rsqb;Birthday【贪心】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj3ow49.html">&lbrack;国家集训队&rsqb;middle 解题报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o76z18.html">jmeter4&period;0测试dubbo接口遇到的问题：An error occurred&colon; org&period;springframework&period;scheduling&period;quartz&period;CronTriggerBean has interface org&period;quartz&period;CronTrigger as super class</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw5nm79.html">JIRA和Confluence更改JVM内存大小解决访问打开缓慢问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyvmm39.html">staitc</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o7pxj8.html">linux &period;&sol;configure check your system clock</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2z5dj9.html">CF132E Bits of merry old England</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwde3z9.html">PHP快速排序算法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
